<template>
	<f7-page 
	name="home"
	@page:beforein="onPageBeforeIn"
	@page:beforeout="onPageBeforeOut"
	ptr 
	@ptr:refresh="onPageRefresh"
	infinite
	:infinite-distance="50"
	:infinite-preloader="showPreloader"
	@infinite="loadMore">
		<!-- Top Navbar -->
		<f7-navbar :sliding="false">
			<f7-nav-title sliding>Doctrin</f7-nav-title>
			<f7-subnavbar id="documents" :inner="false">
                <f7-segmented raised>
                    <f7-button :class="currentTab == 'onprogress' ? 'tab-link-active' : ''" tab-link="#onprogress">On Progress</f7-button>
                    <f7-button :class="currentTab == 'archived' ? 'tab-link-active' : ''" tab-link="#archived">Archived</f7-button>
                </f7-segmented>
            </f7-subnavbar>
		</f7-navbar>

		<!-- Page content-->
		<div v-if="documents.length > 0">
			<f7-block-title>{{ currentTab }}</f7-block-title>
			<f7-list media-list no-hairlines class="no-margin">
				<f7-list-item
					v-for="(document, index) in documents"
					:key="index"
					:title="document.tracking_number"
					:subtitle="document.document_number"
					:text="convertAmpersand(document.title).capitalize()"
					:after="hoursAgo(document.updated)"
					:link="`/document/${document.id}/`">
					<f7-icon slot="media" material="insert_drive_file" style="color:#F46A54;"></f7-icon>

				</f7-list-item>
			</f7-list>
		</div>
		<f7-block v-else-if="documents.length == 0" style="height: calc(100% - 100px)">
			<span class="display-flex align-items-center justify-content-center" style="height:calc(100% - 150px);">
				<span class="text-align-center">
					<span class="display-block text-align-center">
						<f7-icon material="insert_drive_file" size="100" style="color:#F46A54;"></f7-icon>
						<span class="display-block">No Document {{ currentTab.capitalize() }}</span>
					</span>
				</span>
			</span>
		</f7-block>

	</f7-page>
</template>
<script>
import { mapGetters } from 'vuex';
import { dateFormat, convertAmpersand, hoursAgo } from '../js/utils';
import { setTimeout } from 'timers';
export default {
    name: 'Home',
    data(){
        return {
            allowInfinite: true,
            showPreloader: true,
            currentTab: 'onprogress'
        };
    },
    computed: {
        ...mapGetters('auth', ['user']),
        ...mapGetters('document', [
            'documents',
            'pagination'
        ])
	},
	mounted(){
        const self = this;
        const app = self.$f7;
        const $$ = self.$$;

        $$('#documents .tab-link').on('click', function(){
            const $this = $$(this);
            const data = $this.data('tab');
            
            if(data == '#onprogress'){
                self.currentTab = 'onprogress';
            }else if(data == '#archived'){
                self.currentTab = 'archived';
            }

            self.$store.dispatch('document/resetDocuments');

            self.getDocuments(1, false);
        });
	},
	methods:{
		hoursAgo,
		convertAmpersand,
		getDocuments(page, loadmore){
            const self = this;
			const app = self.$f7;
            
			app.preloader.show('red');

            self.$store.dispatch('document/getDocuments', {
                page: page,
                perpage: 25,
                loadmore: loadmore,
                archived: self.currentTab == 'archived' ? true : false
            }).then(()=>{
                setTimeout(()=>{
					app.preloader.hide();
					self.showPreloader = self.pagination.has_next;
				}, 100);
            });
		},
		onPageBeforeIn(){
            const self = this;
            const app = self.$f7;
            const $ = self.$$;

            self.getDocuments(1, false);
        },
        onPageBeforeOut(){
            const self = this;
            const app = self.$f7;
        },
        onPageRefresh(e, done){
			const self = this;
            self.productLoading = true;

            self.$store.dispatch('document/resetDocuments');

			self.getDocuments(1, false);

			done();
		},
		loadMore(){
			const self = this;

			if (!self.allowInfinite) return;
			self.allowInfinite = false;
			setTimeout(()=>{
				if(self.pagination.has_next){                
					self.getDocuments(self.pagination.page + 1, true);
					self.allowInfinite = true;
				}else{
					self.showPreloader = false;
				}
			}, 1000);
        },
	}
};
</script>